clear all 
close all
clc

%% seal
[s,fs,bits] = wavread('vocals.wav');
inici = 1;                      % muestra inicial 
longitud = length(s);           % longitud de seal que queremos tener
final = inici+longitud-1;       % muestra final
s = s(inici:final);             % seal de voz inicial 
s = s/max(abs(s));              % normalizacin

%% parmetros
p = 5;                          % orden del filtro adaptativo
h1 = zeros(p,1);                % inicializacin de coeficientes del filtro
mu = 0.1;                       % valor de mu
s_vect = zeros(p,1);            % inicializacin buffer de la seal

%% algoritmo LMS a toda la seal
for n = 1:longitud-1
    s_vect = [s(n); s_vect(1:p-1)];
    est_s(n)= h1'*s_vect;
    e1(n) = s(n+1)-est_s(n);
    h1 = h1+mu*s_vect*e1(n);
end

norma_error = norm(e1);

%% representaciones grficas
figure(1)
bar(h1)
title('coeficientes del filtro adaptativ segn LMS')

figure(2)
plot(s);
hold on;
plot(est_s,'r');
plot(e1,'g');
title('seal original (azul), seal estimada amb LMS (rojo), error de estimacin (verde)')

%% solucin analtica (Levinson-Durbin)
h2 = lpc(s,p);
figure(3)
bar(-h2(2:end))
title('coeficientes del filtro segn Wiener')
